package ink.wgink.module.map.service.userlocation;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.module.map.pojo.dtos.userlocation.UserLocationDTO;
import ink.wgink.module.map.pojo.vos.userlocation.UserLocationVO;
import ink.wgink.module.map.pojo.bos.userlocation.UserLocationBO;
import ink.wgink.module.map.pojo.pos.userlocation.UserLocationPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IUserLocationService
 * @Description: 用户定位
 * @Author: CodeFactory
 * @Date: 2021-10-29 15:37:01
 * @Version: 3.0
 **/
public interface IUserLocationService {


    /**
     * 新增用户定位
     *
     * @param userId
     * @param userLocationVO
     * @return
     */
    void save(String userId, UserLocationVO userLocationVO);

    /**
     * 新增用户定位
     *
     * @param userId
     * @param userLocationVO
     * @return userLocationId
     */
    String saveAndReturnId(String userId, UserLocationVO userLocationVO);


    /**
     * 删除用户定位
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除用户定位
     *
     * @param token
     * @param ids   id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除用户定位（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改用户定位
     *
     * @param userLocationId
     * @param userLocationVO
     * @return
     */
    void update(String userLocationId, UserLocationVO userLocationVO);

    /**
     * 修改用户定位
     *
     * @param token
     * @param userLocationId
     * @param userLocationVO
     * @return
     */
    void update(String token, String userLocationId, UserLocationVO userLocationVO);

    /**
     * 用户定位详情
     *
     * @param params 参数Map
     * @return
     */
    UserLocationDTO get(Map<String, Object> params);

    /**
     * 用户定位详情
     *
     * @param userLocationId
     * @return
     */
    UserLocationDTO get(String userLocationId);

    /**
     * 用户定位详情
     *
     * @param params 参数Map
     * @return
     */
    UserLocationBO getBO(Map<String, Object> params);

    /**
     * 用户定位详情
     *
     * @param userLocationId
     * @return
     */
    UserLocationBO getBO(String userLocationId);

    /**
     * 用户定位详情
     *
     * @param params 参数Map
     * @return
     */
    UserLocationPO getPO(Map<String, Object> params);

    /**
     * 用户定位详情
     *
     * @param userLocationId
     * @return
     */
    UserLocationPO getPO(String userLocationId);

    /**
     * 用户定位列表
     *
     * @param params
     * @return
     */
    List<UserLocationDTO> list(Map<String, Object> params);

    /**
     * 用户定位列表
     *
     * @param params
     * @return
     */
    List<UserLocationBO> listBO(Map<String, Object> params);

    /**
     * 用户定位列表
     *
     * @param params
     * @return
     */
    List<UserLocationPO> listPO(Map<String, Object> params);

    /**
     * 用户定位分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<UserLocationDTO>> listPage(ListPage page);

    /**
     * 用户定位统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}